"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = ActivityIndicator;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); } // This one caused 100% CPU usage for some reason.
// The `<path/>` animation was causing the CPU load for some reason.
// https://codepen.io/supah/pen/BjYLdW
// https://codepen.io/jczimm/pen/vEBpoL
var radius = 20;
var padding = 0.25; // in `radius`es

var svg_circe_center = radius * (1 + padding);
var svg_canvas_dimensions = "0 0 ".concat(svg_circe_center * 2, " ").concat(svg_circe_center * 2);
// Whatever it is
// https://developer.mozilla.org/docs/Web/SVG/Attribute/stroke-miterlimit
var svg_stroke_miter_limit = radius / 2;
function ActivityIndicator(props) {
  var className = props.className;
  return /*#__PURE__*/_react["default"].createElement("div", _extends({}, props, {
    className: (0, _classnames["default"])('rrui__activity-indicator', className)
  }), /*#__PURE__*/_react["default"].createElement("svg", {
    viewBox: svg_canvas_dimensions,
    className: "rrui__activity-indicator-circle-container"
  }, /*#__PURE__*/_react["default"].createElement("circle", {
    className: "rrui__activity-indicator-circle",
    cx: svg_circe_center,
    cy: svg_circe_center,
    r: radius,
    fill: "none",
    strokeWidth: radius * 0.125,
    strokeMiterlimit: svg_stroke_miter_limit
  })));
}
ActivityIndicator.propTypes = {
  // CSS class
  className: _propTypes["default"].string,
  // CSS style object
  style: _propTypes["default"].object
};
//# sourceMappingURL=ActivityIndicator.old.js.map