"use strict";

var _formatDate = _interopRequireDefault(require("./formatDate"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
describe('formatDate', function () {
  it('should format dates', function () {
    var date = new Date(2018, 3, 5);
    expect((0, _formatDate["default"])(date, 'dd.mm.yyyy')).to.equal('05.04.2018');
    expect((0, _formatDate["default"])(date, 'mm/dd/yyyy')).to.equal('04/05/2018');
    expect((0, _formatDate["default"])(date, 'mm/dd/yy')).to.equal('04/05/18');
  });
});
//# sourceMappingURL=formatDate.test.js.map