"use strict";

var _getLanguageFromLocale = _interopRequireDefault(require("./getLanguageFromLocale"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
describe('getLanguageFromLocale', function () {
  it('should get language from locale', function () {
    expect((0, _getLanguageFromLocale["default"])('ru')).to.equal('ru');
    expect((0, _getLanguageFromLocale["default"])('en-US')).to.equal('en');
    expect((0, _getLanguageFromLocale["default"])('en-Latn-US')).to.equal('en');
    expect((0, _getLanguageFromLocale["default"])('he-IL-u-ca-hebrew-tz-jeruslm')).to.equal('he');
  });
});
//# sourceMappingURL=getLanguageFromLocale.test.js.map