"use strict";

var _transformDateInputAccordingToTemplate = _interopRequireDefault(require("./transformDateInputAccordingToTemplate"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
describe('transformDateInputAccordingToTemplate', function () {
  it('should trim invalid part', function () {
    expect((0, _transformDateInputAccordingToTemplate["default"])('fasdf', 'dd.mm.yyyy')).to.equal('');
    expect((0, _transformDateInputAccordingToTemplate["default"])('01.01.1234', 'dd.mm.yyyy')).to.equal('01.01.1234');
    expect((0, _transformDateInputAccordingToTemplate["default"])('01/02/34', 'mm/dd/yy')).to.equal('01/02/34');
    expect((0, _transformDateInputAccordingToTemplate["default"])('01/a2/34', 'mm/dd/yy')).to.equal('01/');
  });
});
//# sourceMappingURL=transformDateInputAccordingToTemplate.test.js.map