function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React from 'react';
import PropTypes from 'prop-types';
import { polyfill as reactLifecyclesCompat } from 'react-lifecycles-compat';
import classNames from 'classnames';
import ExpandableList from './ExpandableList';
import List from './List';
import Label from './TextInputLabel';
import TextInputInput from './TextInputInput';
import Ellipsis from './Ellipsis';
import WithError from './WithError';
import { onBlurForReduxForm } from './utility/redux-form';
import { submitFormOnCtrlEnter } from './utility/dom';

// `PureComponent` is only available in React >= 15.3.0.
var PureComponent = React.PureComponent || React.Component;
var Autocomplete = /*#__PURE__*/function (_PureComponent) {
  _inherits(Autocomplete, _PureComponent);
  var _super = _createSuper(Autocomplete);
  function Autocomplete() {
    var _this;
    _classCallCheck(this, Autocomplete);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "state", _objectSpread(_objectSpread({
      // The sequential counter for `async getOptions()`:
      // the `options` with the highest counter are shown
      // to prevent "race condition" inconsistency.
      // Older options can only be overwritten with newer ones.
      optionsCounter: 0,
      hasAnyMatchingOptionsCounter: 0
    }, _this.getInputValueAndSelectedOptionForInitialState(_this.props)), {}, {
      options: []
    }));
    // Latest `async getOptions()` invocation timestamp (for throttling).
    _defineProperty(_assertThisInitialized(_this), "latestFetchOptionsCallTimestamp", 0);
    // Older options can only be overwritten with newer ones.
    // (in case of `async getOptions()`).
    _defineProperty(_assertThisInitialized(_this), "counter", new Counter());
    _defineProperty(_assertThisInitialized(_this), "onPreloadStateChange", function (isPreloading) {
      _this.setState({
        isFetchingOptions: isPreloading
      });
    });
    _defineProperty(_assertThisInitialized(_this), "focus", function () {
      _this.input.focus();
    });
    _defineProperty(_assertThisInitialized(_this), "onCollapse", function (_ref) {
      var collapsedDueToItemBeingSelected = _ref.collapsedDueToItemBeingSelected,
        focusOut = _ref.focusOut;
      var _this$props = _this.props,
        acceptsAnyValue = _this$props.acceptsAnyValue,
        emptyValue = _this$props.emptyValue;
      var _this$state = _this.state,
        inputValue = _this$state.inputValue,
        options = _this$state.options,
        selectedOption = _this$state.selectedOption;
      _this.setState({
        isExpanded: false,
        hasAnyMatchingOptions: undefined
      });
      if (!collapsedDueToItemBeingSelected && !_this.collapsedDueToEmptyValueOnEnter) {
        if (!acceptsAnyValue) {
          if (inputValue) {
            // Reset `inputValue` to the last selected option's label.
            _this.setState({
              inputValue: getLabelForOption(selectedOption, {
                acceptsAnyValue: acceptsAnyValue
              }) || ''
            });
          } else {
            // If the user has erased the text input value,
            // clear the `value` property on focus out:
            // on click away / focus away / "Esc" key press.
            _this.setValue(emptyValue);
          }
        }
      }
      if (!focusOut) {
        _this.dontExpandOnFocus = true;
        _this.focus();
        _this.dontExpandOnFocus = false;
      }
    });
    _defineProperty(_assertThisInitialized(_this), "onExpand", function () {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      _this.setState({
        isExpanded: true
      });
    });
    _defineProperty(_assertThisInitialized(_this), "onFocusItem", function (i, options) {
      if (options.interaction) {
        _this.setState({
          focusedOptionIndex: i
        });
      } else {
        _this.setState({
          focusedOptionIndex: undefined
        });
      }
    });
    _defineProperty(_assertThisInitialized(_this), "expand", function () {
      var acceptsAnyValue = _this.props.acceptsAnyValue;
      var inputValue = _this.state.inputValue;

      // Reset `hasAnyMatchingOptions` state property before expanding.
      //
      // `hasAnyMatchingOptions` should be `true` when no value has been input or selected.
      // The reason is because when `hasAnyMatchingOptions` is `false`, the input is considered invalid,
      // and logically it can't be classified as invalid when there's no input yet.
      //
      // When `acceptsAnyValue` is `false` and there's some `inputValue`
      // then it means that the `inputValue` corresponds to one of the selected options
      // so `hasAnyMatchingOptions` is `true` in that case.
      //
      var hasAnyMatchingOptions = inputValue === '' ? true : acceptsAnyValue ? undefined : true;
      _this.setState({
        hasAnyMatchingOptions: hasAnyMatchingOptions
      }, _this._expand);
    });
    _defineProperty(_assertThisInitialized(_this), "_expand", function (parameters) {
      _this.list.expand(parameters);
    });
    // Returns a `Promise`.
    _defineProperty(_assertThisInitialized(_this), "collapse", function () {
      return _this.list.collapse();
    });
    // Returns a `Promise`.
    _defineProperty(_assertThisInitialized(_this), "toggle", function () {
      return _this.list.toggle();
    });
    _defineProperty(_assertThisInitialized(_this), "storeListRef", function (ref) {
      _this.list = ref;
    });
    _defineProperty(_assertThisInitialized(_this), "storeInput", function (node) {
      _this.input = node;
    });
    _defineProperty(_assertThisInitialized(_this), "storeInputComponentNode", function (node) {
      _this.inputComponentNode = node;
    });
    _defineProperty(_assertThisInitialized(_this), "getInputNode", function () {
      return _this.input;
    });
    _defineProperty(_assertThisInitialized(_this), "expandOnFocus", function () {
      if (_this.dontExpandOnFocus) {
        return;
      }
      var isExpanded = _this.state.isExpanded;
      if (!isExpanded) {
        _this.expand();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "onInputValueChange", function (value) {
      var _this$props2 = _this.props,
        acceptsAnyValue = _this$props2.acceptsAnyValue,
        onChange = _this$props2.onChange;
      var isExpanded = _this.state.isExpanded;

      // Rewrite this somehow.
      //
      // When `this.shouldHighlightFirstOption()` is `true`
      // this is a special case when the first option is not highlighted.
      //
      if (!value && isExpanded) {
        _this.list.focusItem(undefined);
      }
      if (acceptsAnyValue) {
        onChange(value);
      }
      _this.setState({
        inputValue: value
      }, function () {
        _this._expand({
          refresh: true
        });
      });
    });
    _defineProperty(_assertThisInitialized(_this), "onKeyDown", function (event) {
      var _this$props3 = _this.props,
        disabled = _this$props3.disabled,
        readOnly = _this$props3.readOnly,
        value = _this$props3.value,
        emptyValue = _this$props3.emptyValue,
        required = _this$props3.required,
        onKeyDown = _this$props3.onKeyDown;
      var _this$state2 = _this.state,
        options = _this$state2.options,
        isExpanded = _this$state2.isExpanded,
        inputValue = _this$state2.inputValue,
        focusedOptionIndex = _this$state2.focusedOptionIndex;
      if (disabled || readOnly) {
        return;
      }
      if (event.defaultPrevented) {
        return;
      }
      if (!isExpanded) {
        if (submitFormOnCtrlEnter(event, _this.input)) {
          return;
        }
      }
      if (event.ctrlKey || event.altKey || event.shiftKey || event.metaKey) {
        return;
      }
      switch (event.keyCode) {
        // "Up" arrow.
        // Select the previous item (if present).
        case 38:
          if (isExpanded) {
            // If no item was selected then do nothing.
            if (_this.list.getFocusedItemIndex() === undefined) {
              // Don't select any list item.
            }
            // If the first item was selected.
            else if (_this.list.getFocusedItemIndex() === 0) {
              // then unselect it.
              if (!_this.shouldHighlightFirstOption()) {
                _this.list.clearFocus();
              }
              event.preventDefault();
            } else {
              _this.list.onKeyDown(event);
            }
          }
          return;

        // "Down" arrow.
        // Select the next item (if present).
        case 40:
          if (isExpanded) {
            // An edge case for `this.shouldHighlightFirstOption() === true`
            // when there's only one option available
            // so pressing "Down" arrow key won't result in
            // `onFocusItem` call which won't set `focusedOptionIndex`
            // in order for screen reader to announce it.
            if (_this.shouldHighlightFirstOption() && focusedOptionIndex === undefined && options.length === 1) {
              _this.setState({
                focusedOptionIndex: 0
              });
            } else {
              // Navigate the list (if it was already expanded).
              _this.list.onKeyDown(event);
            }
          } else {
            // Expand the list if it's collapsed.
            event.preventDefault();
            _this.expand();
          }
          return;

        // "Left" arrow.
        case 37:
        // "Right" arrow.
        case 39:
          // Exit "focus options" mode.
          if (isExpanded) {
            _this.list.clearFocus();
            if (_this.shouldHighlightFirstOption()) {
              _this.list.focusItem(0);
            }
          }
          return;

        // "Escape".
        // Collapse.
        case 27:
          if (isExpanded) {
            event.preventDefault();
            _this.collapse();
          } else {
            if (onKeyDown) {
              onKeyDown(event);
            }
          }
          return;

        // "Enter".
        case 13:
          if (!inputValue) {
            if (onKeyDown) {
              onKeyDown(event);
            }

            // If no option is selected and the input value is empty
            // then set `value` to `undefined`.
            if (isExpanded && _this.list.getFocusedItemIndex() === undefined) {
              // Don't submit the form.
              event.preventDefault();
              _this.setValue(emptyValue);
              _this.collapsedDueToEmptyValueOnEnter = true;
              _this.collapse();
              _this.collapsedDueToEmptyValueOnEnter = undefined;
              return;
            }
            if (!isExpanded) {
              // If `value` is `undefined` and input value is empty
              // then by default it submits the form.
              if (isEmptyValue(value)) {
                // If the value is required then expand the options list.
                if (required) {
                  // Don't submit the form
                  event.preventDefault();
                  _this.expand();
                }
                return;
              }

              // If the input value has been cleared
              // and the options list is collapsed
              // (for example, via Escape key)
              // then set `value` to `undefined`
              // and don't submit the form.
              event.preventDefault();
              _this.setValue(emptyValue);
              return;
            }
          }

          // Select the currently focused item (if expanded).
          if (isExpanded) {
            if (_this.list.getFocusedItemIndex() === undefined) {
              // If the list is expanded and no option is focused
              // then it means that `acceptsAnyValue` is `true`.
              // In that case, it will automatically submit the form.
              _this.collapse();
            } else {
              // Don't submit the form.
              event.preventDefault();
              // Choose the focused option.
              _this.list.chooseFocusedItem();
            }
          }
          return;
      }
    });
    _defineProperty(_assertThisInitialized(_this), "filterOptions", function (options, inputValue) {
      var _this$props4 = _this.props,
        filterOptions = _this$props4.filterOptions,
        caseSensitive = _this$props4.caseSensitive,
        acceptsAnyValue = _this$props4.acceptsAnyValue;
      if (filterOptions) {
        return filterOptions(options, inputValue);
      }
      return getOptionsByInputValue(options, inputValue, {
        caseSensitive: caseSensitive,
        acceptsAnyValue: acceptsAnyValue
      });
    });
    _defineProperty(_assertThisInitialized(_this), "fetchDefaultOptions", function () {
      var getOptions = _this.props.getOptions;
      return Promise.resolve().then(function () {
        return getOptions ? getOptions('') : _this.filterOptions(_this.props.options, '');
      });
    });
    _defineProperty(_assertThisInitialized(_this), "refreshOptions", function () {
      var getOptions = _this.props.getOptions;
      var inputValue = _this.state.inputValue;
      return new Promise(function (resolve) {
        // If throttled then schedule a future invocation.
        if (getOptions) {
          if (_this.throttleFetchOptionsCall(resolve)) {
            return;
          }
          _this.latestFetchOptionsCallTimestamp = Date.now();
          var counter = _this.counter.getNextCounter();
          _this.setState({
            isFetchingOptions: true,
            fetchingOptionsCounter: counter
          }, function () {
            _this.fetchOptionsByInputValue(inputValue).then(function (options) {
              _this.handleNewOptions(options, counter, resolve);
            });
          });
        } else {
          _this.fetchOptionsByInputValue(inputValue).then(function (options) {
            _this.handleNewOptions(options, null, resolve);
          });
        }
      });
    });
    _defineProperty(_assertThisInitialized(_this), "handleNewOptions", function (options, counter, resolve) {
      Promise.resolve(options).then(function (options) {
        // Autocomplete should always display some options,
        // even when none match. The rationale is that otherwise
        // the user could end up entering a non-matching text value
        // and then being stuck with it not knowing how to proceed and why does
        // the text input show an "invalid input" error: without an expanded list of
        // some options it would look like a generic text input field, and to the user
        // it would look like a generic text input field rather than an "autocomplete" component.
        //
        if (options.length === 0 && _this.state.options.length === 0) {
          var fetchFallbackOptions = function fetchFallbackOptions() {
            // The only case when `state.options` is an empty array is the initial state.
            var inputValueForLastSelectedOption = _this.state.inputValueForLastSelectedOption;
            if (inputValueForLastSelectedOption !== undefined) {
              return _this.fetchOptionsByInputValue(inputValueForLastSelectedOption).then(function (options) {
                if (options.length > 0) {
                  return options;
                }
                return _this.fetchDefaultOptions();
              });
            }
            return _this.fetchDefaultOptions();
          };
          return fetchFallbackOptions().then(function (options) {
            // Update `options` in `state`.
            return new Promise(function (resolve) {
              return _this.setState({
                options: options
              }, resolve);
            });
          }).then(function () {
            // Return empty result.
            return [];
          });
        }
        return options;
      }).then(function (options) {
        _this.receiveNewOptions(options, counter, resolve);
      })["catch"](function (error) {
        console.error(error);
        _this.receiveNewOptions([], counter, resolve);
      });
    });
    _defineProperty(_assertThisInitialized(_this), "setValue", function (newValue) {
      var _this$props5 = _this.props,
        value = _this$props5.value,
        onChange = _this$props5.onChange,
        acceptsAnyValue = _this$props5.acceptsAnyValue;
      var options = _this.state.options;
      var selectedOption = options.filter(function (_) {
        return _.value === newValue;
      })[0];
      var inputValue = getLabelForOption(selectedOption, {
        acceptsAnyValue: acceptsAnyValue
      }) || '';
      _this.setState({
        selectedOption: selectedOption,
        options: [selectedOption],
        inputValue: inputValue,
        inputValueForLastSelectedOption: selectedOption ? inputValue : undefined
      });

      // Call `onChange` only if the `value` did change.
      if (newValue !== value) {
        onChange(newValue);
      }
    });
    _defineProperty(_assertThisInitialized(_this), "onBlur", function (event) {
      var _this$props6 = _this.props,
        onBlur = _this$props6.onBlur,
        value = _this$props6.value;
      if (onBlur) {
        onBlurForReduxForm(onBlur, event, value);
      }
      if (_this.list) {
        _this.list.onBlur(event);
      }
    });
    _defineProperty(_assertThisInitialized(_this), "onClick", function (event) {
      var _this$props7 = _this.props,
        disabled = _this$props7.disabled,
        readOnly = _this$props7.readOnly;
      if (disabled || readOnly) {
        return;
      }
      _this.expandOnFocus();
    });
    _defineProperty(_assertThisInitialized(_this), "onFocusOut", function (event) {
      var _this$props8 = _this.props,
        onBlur = _this$props8.onBlur,
        value = _this$props8.value;
      var inputValue = _this.state.inputValue;

      // `window.rruiCollapseOnFocusOut` can be used
      // for debugging expandable contents.
      if (window.rruiCollapseOnFocusOut !== false) {
        _this.collapse();
      }
      if (onBlur) {
        onBlurForReduxForm(onBlur, event, value);
      }
    });
    return _this;
  }
  _createClass(Autocomplete, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // Generate unique ID.
      var id = "rrui-autocomplete";
      while (document.getElementById("".concat(id, "__input"))) {
        id = "rrui-autocomplete-".concat(generateRandomString());
      }
      this.input.id = "".concat(id, "__input");
      this.setState({
        id: id
      });

      // Update `state.inputValue` according to the initial `props.value`
      // when using custom `getOptions`/`getOption` functions.
      var _this$props9 = this.props,
        getOptions = _this$props9.getOptions,
        value = _this$props9.value;
      if (getOptions && !isEmptyValue(value)) {
        this.updateInputValueAndSelectedOptionForValue();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      // If the `value` property has changed, it could be for one of the two reasons:
      // * A developer has passed a new `value` property in order to update it from outside.
      // * This component called `onChange()` with a new `value` as an argument.
      if (prevProps.value !== this.props.value) {
        var _this$props10 = this.props,
          emptyValue = _this$props10.emptyValue,
          value = _this$props10.value,
          acceptsAnyValue = _this$props10.acceptsAnyValue;
        var _this$state3 = this.state,
          selectedOption = _this$state3.selectedOption,
          inputValue = _this$state3.inputValue;
        if (acceptsAnyValue) {
          // In case of `acceptsAnyValue`, it's not obvious
          // whether the `value` was updated externally or as a result
          // of calling `onChange(inputValue)`.
          if (inputValue !== value) {
            // There's no need to set `state.selectedOption` in case of
            // `acceptsAnyValue: true` because for an external observer —
            // the application code — the end result would be the same
            // with or without `state.selectedOption` being set:
            // `value` would be the same regardless.
            // So it only updates the `inputValue` here.
            this.setState({
              inputValue: value,
              // It's not necessary that there's an option that has a value of `value`,
              // so the currently-set `inputValue` doesn't necessarily correspond to any option.
              // Therefore, set this property to `undefine` rather than to `inputValue`.
              inputValueForLastSelectedOption: undefined
            });
          }
        } else {
          // Filter out the cases when this component called `onChange()` with a new `value`
          // as an argument, leaving only the cases when a developer has passed a new `value`
          // property in order to update it from outside.
          if (selectedOption) {
            if (value !== selectedOption.value) {
              // Update `state.inputValue` according to the new `props.value`.
              this.updateInputValueAndSelectedOptionForValue();
            }
          } else {
            if (!isEmptyValue(value)) {
              // Update `state.inputValue` according to the new `props.value`.
              this.updateInputValueAndSelectedOptionForValue();
            }
          }
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.nextFetchOptionsCallTimeout);
    }
  }, {
    key: "updateInputValueAndSelectedOptionForValue",
    value: function updateInputValueAndSelectedOptionForValue() {
      var _this2 = this;
      var _this$props11 = this.props,
        value = _this$props11.value,
        options = _this$props11.options,
        getOptions = _this$props11.getOptions,
        getOption = _this$props11.getOption,
        acceptsAnyValue = _this$props11.acceptsAnyValue;
      var updateStateWithSelectedOption = function updateStateWithSelectedOption(option) {
        var inputValue = _this2.getInputValueForOption(option, {
          value: value,
          acceptsAnyValue: acceptsAnyValue
        });
        _this2.setState({
          selectedOption: option,
          inputValue: inputValue,
          inputValueForLastSelectedOption: option ? inputValue : undefined,
          isFetchingInitiallySelectedOption: false
        });
      };
      this.setState({
        isFetchingInitiallySelectedOption: true
      });
      if (isEmptyValue(value)) {
        updateStateWithSelectedOption(undefined);
        return;
      }
      if (getOptions) {
        // Validate that `getOption` property was passed along with `getOptions` property.
        if (getOptions && !getOption) {
          throw new Error("An initial `value` was passed to `<Autocomplete/>` which has `getOptions` but doesn't have `getOption` to get the label for that initial `value`.");
        }
        getOption(value).then(function (option) {
          updateStateWithSelectedOption(option);
        }, function (error) {
          console.error(error);
          updateStateWithSelectedOption(undefined);
        });
      } else {
        var option = getOptionByValue(value, options);
        updateStateWithSelectedOption(option);
      }
    }
  }, {
    key: "getInputValueForOption",
    value: function getInputValueForOption(option, _ref2) {
      var value = _ref2.value,
        acceptsAnyValue = _ref2.acceptsAnyValue;
      return (option ? getLabelForOption(option, {
        acceptsAnyValue: acceptsAnyValue
      }) : acceptsAnyValue ? value : undefined) || '';
    }
  }, {
    key: "getInputValueAndSelectedOptionForInitialState",
    value: function getInputValueAndSelectedOptionForInitialState(_ref3) {
      var value = _ref3.value,
        acceptsAnyValue = _ref3.acceptsAnyValue,
        options = _ref3.options;
      if (options) {
        var option = getOptionByValue(value, options);
        var inputValue = this.getInputValueForOption(option, {
          value: value,
          acceptsAnyValue: acceptsAnyValue
        });
        return {
          inputValue: inputValue,
          inputValueForLastSelectedOption: option ? inputValue : undefined,
          selectedOption: option
        };
      } else {
        return {
          inputValue: '',
          inputValueForLastSelectedOption: undefined,
          selectedOption: undefined
        };
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props12 = this.props,
        icon = _this$props12.icon,
        compact = _this$props12.compact,
        scroll = _this$props12.scroll,
        scrollMaxItems = _this$props12.scrollMaxItems,
        scrollIntoView = _this$props12.scrollIntoView,
        alignment = _this$props12.alignment,
        saveOnIcons = _this$props12.saveOnIcons,
        optionComponent = _this$props12.optionComponent,
        required = _this$props12.required,
        label = _this$props12.label,
        placeholder = _this$props12.placeholder,
        value = _this$props12.value,
        onChange = _this$props12.onChange,
        acceptsAnyValue = _this$props12.acceptsAnyValue,
        showErrorMessage = _this$props12.showErrorMessage,
        error = _this$props12.error,
        closeButtonIcon = _this$props12.closeButtonIcon,
        closeLabel = _this$props12.closeLabel,
        ScrollableContainer = _this$props12.ScrollableContainer,
        getScrollableContainerHeight = _this$props12.getScrollableContainerHeight,
        getScrollableContainerScrollY = _this$props12.getScrollableContainerScrollY,
        setScrollableContainerScrollY = _this$props12.setScrollableContainerScrollY,
        style = _this$props12.style,
        className = _this$props12.className;
      var _this$state4 = this.state,
        id = _this$state4.id,
        options = _this$state4.options,
        isFetchingOptions = _this$state4.isFetchingOptions,
        isFetchingInitiallySelectedOption = _this$state4.isFetchingInitiallySelectedOption,
        isExpanded = _this$state4.isExpanded,
        inputValue = _this$state4.inputValue;
      var containerStyle = {
        textAlign: alignment
      };

      // ARIA 1.1 (accessibility) docs:
      // https://www.w3.org/TR/wai-aria-practices/examples/combobox/aria1.1pattern/listbox-combo.html
      // (not yet supported)
      //
      // ARIA 1.0 (accessibility) docs:
      // https://www.w3.org/TR/wai-aria-practices/examples/combobox/aria1.0pattern/combobox-autocomplete-list.html
      // (is supported)

      // value={options.length === 0 ? undefined : (inputValue.trim() === '' ? emptyValue : value)}

      return /*#__PURE__*/React.createElement(WithError, {
        id: id,
        error: showErrorMessage ? error : undefined,
        style: style ? _objectSpread(_objectSpread({}, containerStyle), style) : containerStyle,
        className: classNames(className, 'rrui__autocomplete', {
          'rrui__autocomplete--expanded': isExpanded,
          'rrui__autocomplete--compact': compact || icon === true
        })
      }, /*#__PURE__*/React.createElement("div", {
        ref: this.storeInputComponentNode,
        className: "rrui__input"
      }, (isFetchingOptions || isFetchingInitiallySelectedOption) && /*#__PURE__*/React.createElement(Ellipsis, null), this.renderTextInput(), label && /*#__PURE__*/React.createElement(Label, {
        "aria-hidden": true,
        inputId: id ? "".concat(id, "__input") : undefined,
        value: value,
        required: required,
        invalid: error
      }, label), /*#__PURE__*/React.createElement(ExpandableList, {
        ref: this.storeListRef,
        id: id ? "".concat(id, "__list") : undefined,
        items: options,
        value: options.length === 0 ? undefined : value,
        highlightFirstItem: this.shouldHighlightFirstOption() && inputValue.trim() !== '',
        alignment: alignment,
        scrollIntoView: scrollIntoView,
        preload: this.refreshOptions,
        onPreloadStateChange: this.onPreloadStateChange,
        onFocusItem: this.onFocusItem,
        scrollMaxItems: scroll === false ? 0 : scrollMaxItems,
        shouldFocus: false,
        onChange: this.setValue,
        onCollapse: this.onCollapse,
        onExpand: this.onExpand,
        focusOnExpand: false,
        highlightSelectedItem: false,
        tabbable: false,
        getTogglerNode: this.getInputNode,
        onFocusOut: this.onFocusOut,
        ScrollableContainer: ScrollableContainer,
        getScrollableContainerHeight: getScrollableContainerHeight,
        getScrollableContainerScrollY: getScrollableContainerScrollY,
        setScrollableContainerScrollY: setScrollableContainerScrollY,
        closeButtonIcon: closeButtonIcon,
        closeLabel: closeLabel,
        "aria-label": this.props['aria-label'] || label,
        className: classNames('rrui__shadow', 'rrui__options-list', {
          'rrui__options-list--left-aligned': alignment === 'left',
          'rrui__options-list--right-aligned': alignment === 'right'
        })
      }, this.getOptionsForRendering().map(function (option, i) {
        return /*#__PURE__*/React.createElement(List.Item, {
          key: i,
          id: id ? "".concat(id, "__list-item-").concat(i) : undefined,
          value: option.value,
          item: optionComponent ? option : undefined,
          component: optionComponent,
          icon: saveOnIcons ? undefined : option.icon
        }, optionComponent ? undefined : option.content ? option.content(option) : getLabelForOption(option, {
          acceptsAnyValue: acceptsAnyValue
        }));
      }))));
    }
  }, {
    key: "renderTextInput",
    value: function renderTextInput() {
      var _this$props13 = this.props,
        value = _this$props13.value,
        label = _this$props13.label,
        icon = _this$props13.icon,
        placeholder = _this$props13.placeholder,
        disabled = _this$props13.disabled,
        readOnly = _this$props13.readOnly,
        required = _this$props13.required,
        error = _this$props13.error,
        tabIndex = _this$props13.tabIndex,
        autoFocus = _this$props13.autoFocus,
        autoComplete = _this$props13.autoComplete,
        acceptsAnyValue = _this$props13.acceptsAnyValue,
        inputClassName = _this$props13.inputClassName;
      var _this$state5 = this.state,
        id = _this$state5.id,
        isExpanded = _this$state5.isExpanded,
        inputValue = _this$state5.inputValue,
        hasAnyMatchingOptions = _this$state5.hasAnyMatchingOptions,
        isFetchingInitiallySelectedOption = _this$state5.isFetchingInitiallySelectedOption,
        focusedOptionIndex = _this$state5.focusedOptionIndex;

      // To expand on click/focus:
      // onFocus={ this.expandOnFocus }
      // onClick={ this.onClick }

      // WAI-ARIA 1.0 impelmentation info (accessibility):
      // https://www.w3.org/TR/wai-aria-practices/#combobox
      // https://www.levelaccess.com/differences-aria-1-0-1-1-changes-rolecombobox/

      var Icon = typeof icon === 'boolean' ? undefined : icon;
      return /*#__PURE__*/React.createElement(React.Fragment, null, Icon && /*#__PURE__*/React.createElement(Icon, {
        className: "rrui__input-field__icon"
      }), /*#__PURE__*/React.createElement(TextInputInput, {
        id: id ? "".concat(id, "__input") : undefined,
        ref: this.storeInput,
        value: inputValue,
        label: label,
        placeholder: placeholder,
        onChange: this.onInputValueChange,
        onKeyDown: this.onKeyDown,
        onBlur: this.onBlur,
        role: "combobox",
        "aria-autocomplete": "list",
        "aria-expanded": isExpanded ? true : false,
        "aria-haspopup": true,
        "aria-owns": id && isExpanded ? "".concat(id, "__list") : undefined,
        "aria-activedescendant": id && focusedOptionIndex !== undefined ? "".concat(id, "__list-item-").concat(focusedOptionIndex) : undefined,
        required: required,
        tabIndex: tabIndex,
        autoFocus: autoFocus,
        autoComplete: autoComplete,
        disabled: disabled,
        readOnly: isFetchingInitiallySelectedOption || readOnly,
        error: error || (acceptsAnyValue ? undefined : hasAnyMatchingOptions === false ? 'no-match' : undefined),
        className: classNames('rrui__autocomplete__input', inputClassName, {
          'rrui__input-field--with-icon': Icon
        })
      }));
    }
  }, {
    key: "getOptionsForRendering",
    value: function getOptionsForRendering() {
      var maxOptions = this.props.maxOptions;
      var options = this.state.options;
      if (maxOptions > 0 && options.length > maxOptions) {
        return options.slice(0, maxOptions);
      }
      return options;
    }
  }, {
    key: "throttleFetchOptionsCall",
    value: function throttleFetchOptionsCall(resolve) {
      var _this3 = this;
      var _this$props14 = this.props,
        throttle = _this$props14.throttle,
        minCharactersToStartThrottling = _this$props14.minCharactersToStartThrottling;
      var inputValue = this.state.inputValue;
      var wait = throttle - (Date.now() - this.latestFetchOptionsCallTimestamp);
      if (inputValue.length >= minCharactersToStartThrottling && wait > 0) {
        if (!this.nextFetchOptionsCallTimeout) {
          this.nextFetchOptionsCallTimeout = setTimeout(function () {
            _this3.nextFetchOptionsCallTimeout = undefined;
            _this3.latestFetchOptionsCall();
          }, wait);
        }
        this.latestFetchOptionsCall = function () {
          return _this3.refreshOptions().then(resolve);
        };
        return true;
      }
    }
  }, {
    key: "fetchOptionsByInputValue",
    value: function fetchOptionsByInputValue(inputValue) {
      var getOptions = this.props.getOptions;
      if (getOptions) {
        return getOptions(inputValue);
      } else {
        return Promise.resolve(this.filterOptions(this.props.options, inputValue));
      }
    }
  }, {
    key: "receiveNewOptions",
    value: function receiveNewOptions(options, counter, callback) {
      var getOptions = this.props.getOptions;
      var _this$state6 = this.state,
        isExpanded = _this$state6.isExpanded,
        hasAnyMatchingOptionsCounter = _this$state6.hasAnyMatchingOptionsCounter,
        optionsCounter = _this$state6.optionsCounter,
        fetchingOptionsCounter = _this$state6.fetchingOptionsCounter;
      var newState = {};
      if (getOptions) {
        // Can only override "older" matching state.
        if (isCounterAfter(counter, hasAnyMatchingOptionsCounter)) {
          newState.hasAnyMatchingOptions = options.length > 0;
          newState.hasAnyMatchingOptionsCounter = counter;
        }

        // Update options.
        // Can only override "older" options.
        // (not "newer" ones)
        if (isCounterAfter(counter, optionsCounter)) {
          // Autocomplete should always display some options.
          // The only case when `state.options` is an empty array is the initial state.
          if (options.length > 0) {
            newState.options = options;
            newState.optionsCounter = counter;
          }
        }
        if (counter === fetchingOptionsCounter) {
          newState.isFetchingOptions = false;
          newState.fetchingOptionsCounter = undefined;
        }
      } else {
        newState.hasAnyMatchingOptions = options.length > 0;

        // Autocomplete should always display some options.
        if (options.length > 0) {
          newState.options = options;
        }
      }
      if (newState.hasAnyMatchingOptions === false && !this.shouldHighlightFirstOption()) {
        if (isExpanded) {
          this.list.clearFocus();
        }
      }
      this.setState(newState, callback);
    }
  }, {
    key: "shouldHighlightFirstOption",
    value: function shouldHighlightFirstOption() {
      var _this$props15 = this.props,
        acceptsAnyValue = _this$props15.acceptsAnyValue,
        highlightFirstOption = _this$props15.highlightFirstOption;

      // Return a default value for the `highlightFirstOption` property.
      if (highlightFirstOption === undefined) {
        if (acceptsAnyValue) {
          return false;
        }
        return true;
      }
      return highlightFirstOption;
    }
  }]);
  return Autocomplete;
}(PureComponent);
_defineProperty(Autocomplete, "propTypes", {
  // A list of selectable options
  options: PropTypes.arrayOf(PropTypes.shape({
    // Option value (can also be `null` or `undefined`)
    value: PropTypes.any,
    // Could restrict it to stringifiable types
    // but I guess this is not required
    // and one could even use `object`s as `value`s.
    // // Option value (can also be `null` or `undefined`)
    // value : PropTypes.oneOfType([
    // 	PropTypes.string,
    // 	PropTypes.number,
    // 	PropTypes.bool
    // ]),
    // Option label (can be `undefined`)
    label: PropTypes.string,
    // Option icon
    icon: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
    // Render custom content (a React component).
    // Receives `{ value, label }` properties.
    content: PropTypes.func
  })),
  // An alternative way of getting `options`.
  // If it's an `autocomplete` then this function
  // receives the `query : string` argument.
  // Is only for `autocomplete` mode.
  // Must return a `Promise`.
  getOptions: PropTypes.func,
  // Can be supplied when supplying `options` prop.
  // By default filters by substring inclusion (case-insensitive).
  filterOptions: PropTypes.func,
  // The maximum number of options to be rendered
  // in the options list when it's expanded.
  // `0` means "unlimited".
  maxOptions: PropTypes.number,
  // Throttle `async getOptions()` invocations.
  throttle: PropTypes.number.isRequired,
  // Throttle `async getOptions()` invocations.
  minCharactersToStartThrottling: PropTypes.number.isRequired,
  // Option component.
  // (when `<Autocomplete/>` is expanded).
  // Receives properties:
  // * `{ ...option }` — All properties of an `option` such as `value`, `label`, etc. Each `option` must have a `value` and a `label` (`value` can also be `null` or `undefined`).
  // * `selected: boolean` — If this option is selected.
  // * `focused: boolean` — If this option is focused.
  // * `disabled: boolean` — If this option is disabled. Seems to be not used for now.
  // Can only contain "inline" elements like `<span/>`,
  // not `<div/>`s, `<section/`>s, `<h1/>`s or `<p/>`s,
  // because `<button/>`s can't contain "block" elements.
  // `display: block` can still be set on `<span/>`s and other "inline" elements.
  optionComponent: PropTypes.elementType,
  // HTML form input `name` attribute
  name: PropTypes.string,
  // Label which is placed above the select
  label: PropTypes.string,
  // Placeholder (like "Choose")
  placeholder: PropTypes.string,
  // Show icon only for selected item,
  // and only if `icon` is `true`.
  saveOnIcons: PropTypes.bool,
  // Disables this control
  disabled: PropTypes.bool,
  // HTML `readOnly` attribute
  readOnly: PropTypes.bool,
  // Set to `true` to mark the field as required
  required: PropTypes.bool.isRequired,
  // Indicates that the input is invalid.
  error: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  showErrorMessage: PropTypes.bool,
  // When `acceptsAnyValue` is `true`, the user is not required to select any of the options.
  // That could be used when the list of options is not a full one.
  // * `<input/>` value won't be reset when focusing out of the `<input/>`
  //   after not having selected any option.
  // * `onChange()` will be called for every change of the `<input/>` value,
  //   not just when the user has selected some option.
  acceptsAnyValue: PropTypes.bool,
  // When `findOptions()` property function is not provided,
  // the default one will match options by `<input/>` value
  // case-insensitive by default.
  caseSensitive: PropTypes.bool,
  // Selected option value
  value: PropTypes.any,
  // `value` for cases when the input gets cleared.
  emptyValue: PropTypes.any,
  // Is called when an option is selected
  onChange: PropTypes.func,
  // Is called when the select is blurred.
  // This `onBlur` interceptor is a workaround for `redux-form`,
  // so that it gets the parsed `value` in its `onBlur` handler,
  // not the formatted text.
  onBlur: PropTypes.func,
  // If `scroll` is `false`, then options list
  // is not limited in height.
  // Is `true` by default (scrollable).
  scroll: PropTypes.bool.isRequired,
  // Component CSS class
  className: PropTypes.string,
  // Autocomplete `<input/>` CSS class
  inputClassName: PropTypes.string,
  // CSS style object
  style: PropTypes.object,
  // If the `icon` flag is set to `true`,
  // and `icon` is specified for a selected option,
  // then the selected option will be displayed
  // as icon only, without the label
  // (was used in early versions of `react-phone-number-input`).
  // Otherwise, if it's a React component
  // then it's passed to `<TextInputInput/>` as its `icon`.
  icon: PropTypes.oneOfType([PropTypes.elementType, PropTypes.bool]),
  // If this flag is set to `true`,
  // then it makes `<Autocomplete/>` not stretch itself
  // to 100% width by making it `inline-block`.
  // Is set to `true` when `icon` is `true`
  // because it makes sense.
  compact: PropTypes.bool,
  // HTML `tabindex` attribute
  tabIndex: PropTypes.number,
  // HTML `autoFocus` attribute
  autoFocus: PropTypes.bool,
  // `onKeyDown()` doesn't get called in all cases.
  // Currently it's only called in cases:
  // * Pressed `Esc` when the options list is not expanded.
  // * Pressed `Enter` when the input is empty.
  onKeyDown: PropTypes.func,
  // HTML `autocomplete` attribute.
  // Set to "off" to disable any autocompletion in a web browser.
  // https://developer.mozilla.org/en-US/docs/Web/Security/Securing_your_site/Turning_off_form_autocompletion
  autoComplete: PropTypes.string,
  // `<Autocomplete/>` loads `async getOptions()` after it has been mounted.
  // Until then `<Autocomplete/>` doesn't display any selected option.
  // One may supply an already pre-loaded currently selected option
  // to display the currently selected option sooner (e.g. Server-Side Rendering).
  selectedOption: PropTypes.object,
  // WAI-ARIA requires any option be focused only on-demand
  // when the user explicitly presses the Down arrow key.
  // https://www.w3.org/TR/wai-aria-practices/examples/combobox/aria1.0pattern/combobox-autocomplete-list.html
  // Still, it's not be the best user experience for non-disabled users:
  // it would be more convenient for them if the first option was automatically focused.
  // Hence, this property allows a developer customize this type of behavior.
  //
  // When set to `true`, it automatically highlights the top-most option.
  // UX for non-disabled users is better this way.
  // Disabled users still can use this component.
  //
  // Can be explicitly set to `false` for WAI-ARIA compliancy.
  //
  highlightFirstOption: PropTypes.bool,
  ScrollableContainer: PropTypes.elementType,
  getScrollableContainerHeight: PropTypes.func,
  getScrollableContainerScrollY: PropTypes.func,
  setScrollableContainerScrollY: PropTypes.func
});
_defineProperty(Autocomplete, "defaultProps", {
  // Set to `true` to mark the field as required
  required: false,
  // Show `error` (if passed).
  showErrorMessage: true,
  // Set to `true` to display the loading indicator
  loading: false,
  // Will show scrollbar on overflow.
  scroll: true,
  alignment: 'left',
  // `async getOptions()` throttle period.
  throttle: 200,
  // `async getOptions()` throttle threshold (in characters).
  minCharactersToStartThrottling: 4,
  // The maximum number of options to be rendered
  // in the options list when it's expanded.
  // The rationale is that otherwise the UI could
  // stagger when initially expanding a huge list.
  // `0` means "unlimited".
  maxOptions: 500
});
export default reactLifecyclesCompat(Autocomplete);
function isEmptyValue(value) {
  return value === null || value === undefined;
}

// Filters options by substring inclusion (case-insensitive).
function getOptionsByInputValue(options, inputValue, _ref4) {
  var caseSensitive = _ref4.caseSensitive,
    acceptsAnyValue = _ref4.acceptsAnyValue;
  // If the input value is empty.
  if (!inputValue) {
    return options;
  }
  if (!caseSensitive) {
    inputValue = inputValue.toLowerCase();
  }
  return options.filter(function (option) {
    var label = getLabelForOption(option, {
      acceptsAnyValue: acceptsAnyValue
    });
    if (typeof label === 'string') {
      if (!caseSensitive) {
        label = label.toLowerCase();
      }
      return label.indexOf(inputValue) >= 0;
    } else {
      return false;
    }
  });
}
function getOptionByValue(value, options) {
  return options.filter(function (option) {
    return option.value === value;
  })[0];
}
function getLabelForOption(option, _ref5) {
  var acceptsAnyValue = _ref5.acceptsAnyValue;
  if (!option) {
    return undefined;
  }
  // When passing `acceptsAnyValue={true}` property, the `options` can't contain `label`s.
  // Otherwise, the users would observe a weird behavior when, for example, there's an
  // `option` having value `"a"` and label `"Apple"` and they start inputting letter `"a"`
  // in the text input: it would immediately select `"Apple"` because `inputValue === option.value`,
  // which would be considered "weird" by the users because users don't see `option.value`s.
  // To make the behavior of the autocomplete logical in cases like that, the component
  // will show `option.value`s in place of `option.label`s.
  if (acceptsAnyValue) {
    return option.value;
  }
  return option.label;
}
var Counter = /*#__PURE__*/function () {
  function Counter() {
    _classCallCheck(this, Counter);
    _defineProperty(this, "counter", 0);
  }
  _createClass(Counter, [{
    key: "getNextCounter",
    value: function getNextCounter() {
      if (this.counter < MAX_SAFE_INTEGER) {
        this.counter++;
      } else {
        this.counter = 1;
      }
      return this.counter;
    }
  }]);
  return Counter;
}(); // `MAX_SAFE_INTEGER` is not supported by older browsers
var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || Math.pow(2, 53) - 1;

// Can only override "older" options.
// (not "newer" ones)
function isCounterAfter(counter, currentStateCounter) {
  var diff = counter - currentStateCounter;

  // If the new options are "newer" than the current ones,
  // then they can override them.
  // (also accounts for counter overflow)
  return diff > 0 || diff < 0 && Math.abs(diff) > MAX_SAFE_INTEGER / 2;
}
function generateRandomString() {
  return Math.random().toString().replace(/\D/g, '');
}
//# sourceMappingURL=Autocomplete.js.map