import React from 'react';
import classNames from 'classnames';
export default function Divider(_ref) {
  var style = _ref.style,
    className = _ref.className;
  return /*#__PURE__*/React.createElement("div", {
    role: "separator",
    style: style,
    className: classNames(className, 'rrui__divider')
  }, /*#__PURE__*/React.createElement("hr", {
    className: "rrui__divider__line"
  }));
}

// Workaround for `react-hot-loader`.
// https://github.com/gaearon/react-hot-loader#checking-element-types
Divider.displayName = 'Divider';
//# sourceMappingURL=Divider.js.map