function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

// For some weird reason, in Chrome, `setTimeout()` would lag up to a second (or more) behind.
// Turns out, Chrome developers have deprecated `setTimeout()` API entirely without asking anyone.
// Replacing `setTimeout()` with `requestAnimationFrame()` can work around that Chrome bug.
// https://github.com/bvaughn/react-virtualized/issues/722
import { setTimeout, clearTimeout } from 'request-animation-frame-timeout';
var FadeInOut = /*#__PURE__*/function (_React$Component) {
  _inherits(FadeInOut, _React$Component);
  var _super = _createSuper(FadeInOut);
  function FadeInOut(props) {
    var _this;
    _classCallCheck(this, FadeInOut);
    _this = _super.call(this, props);
    _defineProperty(_assertThisInitialized(_this), "state", {
      show: _this.props.show
    });
    _defineProperty(_assertThisInitialized(_this), "hide", function () {
      var fadeOutDuration = _this.props.fadeOutDuration;
      clearTimeout(_this.showTimer);
      if (!_this._isMounted) {
        return;
      }
      _this.setState({
        show: false,
        fadeIn: false,
        fadeOut: true
      });

      // Gives some time to CSS opacity transition to finish.
      _this.hideTimer = setTimeout(function () {
        if (_this._isMounted) {
          _this.setState({
            fadeOut: false
          });
        }
      }, fadeOutDuration);
    });
    if (typeof props.children === 'string' || React.Children.count(props.children) !== 1) {
      throw new Error('`<FadeInOut/>` expect an element as a child.');
    }
    return _this;
  }
  _createClass(FadeInOut, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (!prevProps.show && this.props.show) {
        this.show();
      } else if (prevProps.show && !this.props.show) {
        this.hide();
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
        show = _this$props.show,
        fadeInInitially = _this$props.fadeInInitially;
      this._isMounted = true;
      if (show && fadeInInitially) {
        this.show();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._isMounted = false;
      clearTimeout(this.showTimer);
      clearTimeout(this.hideTimer);
    }
  }, {
    key: "show",
    value: function show() {
      var _this2 = this;
      clearTimeout(this.showTimer);
      clearTimeout(this.hideTimer);
      this.setState({
        show: true,
        fadeIn: false,
        fadeOut: false
      });
      this.showTimer = setTimeout(function () {
        if (_this2._isMounted) {
          _this2.setState({
            fadeIn: true
          });
        }
      },
      // Adding a non-null delay in order to
      // prevent web browser from optimizing
      // adding CSS classes and doing it simultaneously
      // rather than sequentially (required for CSS transition).
      30);
    }
  }, {
    key: "getFadeInStyle",
    value: function getFadeInStyle() {
      var fadeInDuration = this.props.fadeInDuration;
      return {
        opacity: 1,
        transition: "opacity ".concat(fadeInDuration, "ms ease-out")
      };
    }
  }, {
    key: "getFadeOutStyle",
    value: function getFadeOutStyle() {
      var fadeOutDuration = this.props.fadeOutDuration;
      return {
        opacity: 0,
        transition: "opacity ".concat(fadeOutDuration, "ms ease-out")
      };
    }
  }, {
    key: "getStyle",
    value: function getStyle() {
      var _this$props2 = this.props,
        show = _this$props2.show,
        fadeInInitially = _this$props2.fadeInInitially;
      var _this$state = this.state,
        fadeIn = _this$state.fadeIn,
        fadeOut = _this$state.fadeOut;
      if (fadeIn) {
        return this.getFadeInStyle();
      }
      if (fadeOut) {
        return this.getFadeOutStyle();
      }

      // On first render.
      // If `show={true}` and hasn't faded in/out yet, then just show.
      if (show && fadeIn === undefined && !fadeInInitially) {
        return SHOWN_STYLE;
      }
      return HIDDEN_STYLE;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        fadeInClassName = _this$props3.fadeInClassName,
        style = _this$props3.style,
        children = _this$props3.children;
      var _this$state2 = this.state,
        show = _this$state2.show,
        fadeIn = _this$state2.fadeIn,
        fadeOut = _this$state2.fadeOut;
      if (show || fadeOut) {
        var _style = children.props.style ? _objectSpread(_objectSpread({}, children.props.style), this.getStyle()) : this.getStyle();
        if (fadeInClassName) {
          return /*#__PURE__*/React.cloneElement(children, {
            // Set `opacity` correctly on first render
            // if `fadeInInitially` is not `true`.
            style: fadeIn === undefined ? _style : undefined,
            className: classNames(children.props.className, _defineProperty({}, fadeInClassName, fadeIn))
          });
        } else {
          return /*#__PURE__*/React.cloneElement(children, {
            style: _style
          });
        }
        // return children
      }

      return null;
    }
  }]);
  return FadeInOut;
}(React.Component);
_defineProperty(FadeInOut, "propTypes", {
  show: PropTypes.bool.isRequired,
  fadeInInitially: PropTypes.bool.isRequired,
  fadeInDuration: PropTypes.number,
  fadeOutDuration: PropTypes.number,
  fadeInClassName: PropTypes.string,
  children: PropTypes.element.isRequired
});
_defineProperty(FadeInOut, "defaultProps", {
  show: false,
  fadeInInitially: false,
  fadeInDuration: 0,
  fadeOutDuration: 0
});
export { FadeInOut as default };
var SHOWN_STYLE = {
  opacity: 1
};
var HIDDEN_STYLE = {
  opacity: 0
};
//# sourceMappingURL=FadeInOut.js.map