function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["link", "className", "component", "icon", "children", "menuIsExpanded", "toggleMenu", "registerMenuButton"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

// For some weird reason, in Chrome, `setTimeout()` would lag up to a second (or more) behind.
// Turns out, Chrome developers have deprecated `setTimeout()` API entirely without asking anyone.
// Replacing `setTimeout()` with `requestAnimationFrame()` can work around that Chrome bug.
// https://github.com/bvaughn/react-virtualized/issues/722
import { setTimeout, clearTimeout } from 'request-animation-frame-timeout';
import { Context } from './PageAndMenu';
import MenuIcon from './MenuIcon';
var ContextAwareMenuButton = function ContextAwareMenuButton(props) {
  return /*#__PURE__*/React.createElement(Context.Consumer, null, function (context) {
    return /*#__PURE__*/React.createElement(MenuButton, _extends({}, props, {
      registerMenuButton: context.registerMenuButton,
      toggleMenu: context.toggleMenu,
      menuIsExpanded: context.menuIsExpanded
    }));
  });
};
export default ContextAwareMenuButton;
var MenuButton = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(MenuButton, _React$PureComponent);
  var _super = _createSuper(MenuButton);
  function MenuButton() {
    var _this;
    _classCallCheck(this, MenuButton);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "onClick", function (event) {
      event.preventDefault();
      var toggleMenu = _this.props.toggleMenu;
      // A workaround for Safari (both macOS and iOS) bug: `<button/>`s not getting focus.
      // https://stackoverflow.com/questions/20359962/jquery-mobile-focusout-event-for-relatedtarget-returns-incorrect-result-in-safar
      if (!_this.cooldown) {
        toggleMenu();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "setCooldown", function () {
      // A workaround for Safari (both macOS and iOS) bug: `<button/>`s not getting focus.
      // https://stackoverflow.com/questions/20359962/jquery-mobile-focusout-event-for-relatedtarget-returns-incorrect-result-in-safar
      // Sets a small "cooldown" on hide on focus out.
      _this.cooldown = true;
      _this.cooldownTimer = setTimeout(function () {
        return _this.cooldown = false;
      }, 30);
    });
    _defineProperty(_assertThisInitialized(_this), "storeButtonNode", function (node) {
      return _this.button = node;
    });
    return _this;
  }
  _createClass(MenuButton, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      var registerMenuButton = this.props.registerMenuButton;
      this.unregister = registerMenuButton({
        element: function element() {
          return _this2.button;
        },
        setCooldown: this.setCooldown
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.unregister();
      clearTimeout(this.cooldownTimer);
    }
  }, {
    key: "getChildren",
    value: function getChildren() {
      var _this$props = this.props,
        menuIsExpanded = _this$props.menuIsExpanded,
        children = _this$props.children,
        icon = _this$props.icon;
      if (children) {
        if (typeof children === 'function') {
          return children({
            expanded: menuIsExpanded
          });
        }
        return children;
      }
      return /*#__PURE__*/React.createElement(icon || MenuIcon, {
        expanded: menuIsExpanded
      });
    }
  }, {
    key: "getButtonProps",
    value: function getButtonProps() {
      var menuIsExpanded = this.props.menuIsExpanded;
      return {
        ref: this.storeButtonNode,
        onClick: this.onClick,
        // 'aria-label': 'Menu',
        // 'aria-haspopup': 'menu',
        // `menuIsExpanded` property can be `undefined` to differentiate
        // between "has been toggled yet"/"has not been toggled yet"
        // to workaround the CSS animation bug.
        'aria-expanded': menuIsExpanded ? true : false
      };
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        link = _this$props2.link,
        className = _this$props2.className,
        component = _this$props2.component,
        MenuButtonIcon = _this$props2.icon,
        children = _this$props2.children,
        menuIsExpanded = _this$props2.menuIsExpanded,
        toggleMenu = _this$props2.toggleMenu,
        registerMenuButton = _this$props2.registerMenuButton,
        rest = _objectWithoutProperties(_this$props2, _excluded);
      var properties = _objectSpread(_objectSpread({}, rest), this.getButtonProps());
      if (component) {
        return /*#__PURE__*/React.createElement(component, properties);
      }
      properties.className = classNames('rrui__button-reset', 'rrui__outline', className, {
        // Only when using an `icon` component.
        'rrui__menu-button': !component && !children
      });

      // A link.
      if (link) {
        return /*#__PURE__*/React.createElement('a', _objectSpread(_objectSpread({}, properties), {}, {
          href: link
        }), this.getChildren());
      }

      // A button.
      return /*#__PURE__*/React.createElement('button', _objectSpread(_objectSpread({}, properties), {}, {
        type: 'button'
      }), this.getChildren());
    }
  }]);
  return MenuButton;
}(React.PureComponent);
_defineProperty(MenuButton, "propTypes", {
  // Context.
  registerMenuButton: PropTypes.func.isRequired,
  toggleMenu: PropTypes.func.isRequired,
  menuIsExpanded: PropTypes.bool,
  //.isRequired,

  // A URL of the "Menu" page:
  // if a web browser has javascript disabled (e.g. Tor),
  // then the menu button will redirect to this Menu page URL.
  // If not set then won't redirect anywhere.
  link: PropTypes.string,
  // HTML `title` attribute.
  title: PropTypes.string,
  // Menu button component.
  component: PropTypes.elementType,
  // Menu button icon component.
  icon: PropTypes.func,
  // CSS class.
  className: PropTypes.string,
  // CSS style object.
  style: PropTypes.object,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func])
});
//# sourceMappingURL=MenuButton.js.map