import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
export default function MenuIcon(_ref) {
  var expanded = _ref.expanded,
    className = _ref.className;
  // This is to prevent the `transform` animations
  // of menu icon bars from being played on page load.
  // (when styles are included on a page via javascript)
  var activated = expanded !== undefined;
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(className, 'rrui__menu-icon', {
      'rrui__menu-icon--collapsed': !expanded,
      'rrui__menu-icon--expanded': expanded
    })
  }, /*#__PURE__*/React.createElement("div", {
    className: "rrui__menu-icon__bar"
  }), /*#__PURE__*/React.createElement("div", {
    className: "rrui__menu-icon__bar"
  }), /*#__PURE__*/React.createElement("div", {
    className: "rrui__menu-icon__bar"
  }));
}
MenuIcon.propTypes = {
  expanded: PropTypes.bool,
  className: PropTypes.string
};
//# sourceMappingURL=MenuIcon.js.map