function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { submitFormOnCtrlEnter } from './utility/dom';
import { onBlurForReduxForm } from './utility/redux-form';

// `PureComponent` is only available in React >= 15.3.0.
var PureComponent = React.PureComponent || React.Component;

// http://wd.dizaina.net/en/experiments/ios7-style-switch/

// An iOS-style switch
var Switch = /*#__PURE__*/function (_PureComponent) {
  _inherits(Switch, _PureComponent);
  var _super = _createSuper(Switch);
  function Switch() {
    var _this;
    _classCallCheck(this, Switch);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "state", {});
    _defineProperty(_assertThisInitialized(_this), "state", {});
    // // Prevent "blur" event on mouse down.
    // onMouseDown = (event) => event.preventDefault()
    _defineProperty(_assertThisInitialized(_this), "onFocus", function (event) {
      var onFocus = _this.props.onFocus;
      if (onFocus) {
        onFocus(event);
      }
      _this.setState({
        isFocused: true
      });
    });
    _defineProperty(_assertThisInitialized(_this), "onBlur", function (event) {
      var _this$props = _this.props,
        onBlur = _this$props.onBlur,
        value = _this$props.value;
      if (onBlur) {
        onBlurForReduxForm(onBlur, event, value);
      }
      _this.setState({
        isFocused: false
      });
    });
    _defineProperty(_assertThisInitialized(_this), "onKeyDown", function (event) {
      var onKeyDown = _this.props.onKeyDown;
      if (onKeyDown) {
        onKeyDown(event);
      }
      if (event.defaultPrevented) {
        return;
      }
      if (submitFormOnCtrlEnter(event, _this.input)) {
        return;
      }
    });
    _defineProperty(_assertThisInitialized(_this), "storeInputComponent", function (_) {
      return _this.input = _;
    });
    // render_static()
    // {
    // 	const { name, disabled, value } = this.props
    //
    // 	return (
    // 		<div className="rrui__rich__fallback">
    // 			<input
    // 				type="checkbox"
    // 				name={ name }
    // 				disabled={ disabled }
    // 				value={ value }/>
    // 		</div>
    // 	)
    // }
    _defineProperty(_assertThisInitialized(_this), "toggle", function (event) {
      var _this$props2 = _this.props,
        onChange = _this$props2.onChange,
        disabled = _this$props2.disabled,
        value = _this$props2.value;
      if (disabled) {
        return;
      }
      onChange(!value);
    });
    return _this;
  }
  _createClass(Switch, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        value = _this$props3.value,
        disabled = _this$props3.disabled,
        style = _this$props3.style,
        className = _this$props3.className,
        leftLabel = _this$props3.leftLabel,
        rightLabel = _this$props3.rightLabel,
        rightContent = _this$props3.rightContent,
        placement = _this$props3.placement,
        children = _this$props3.children;
      var isFocused = this.state.isFocused;
      var isRightSideContent = placement === 'left' || rightContent;
      var hasLabel = children || leftLabel || rightLabel || rightContent;
      return /*#__PURE__*/React.createElement("label", {
        onMouseDown: this.onMouseDown,
        onFocus: this.onFocus,
        onBlur: this.onBlur,
        style: style,
        className: classNames(className, 'rrui__switch', {
          'rrui__input': hasLabel,
          'rrui__switch--label': children,
          'rrui__switch--disabled': disabled,
          'rrui__switch--focus': isFocused,
          'rrui__switch--on': value
        })
      }, (leftLabel || !isRightSideContent && children) && /*#__PURE__*/React.createElement("span", {
        className: classNames('rrui__text-line', 'rrui__switch__label', 'rrui__switch__label--left', {
          'rrui__switch__label--on': value
        })
      }, leftLabel || !isRightSideContent && children), /*#__PURE__*/React.createElement("span", {
        className: "rrui__switch__switch"
      }, /*#__PURE__*/React.createElement("input", {
        ref: this.storeInputComponent,
        type: "checkbox",
        value: value,
        onKeyDown: this.onKeyDown,
        onChange: this.toggle,
        className: "rrui__switch__input",
        style: inputStyle
      }), /*#__PURE__*/React.createElement("span", {
        className: classNames('rrui__switch__groove', {
          // CSS selector performance optimization
          'rrui__switch__groove--on': value
        })
      }), /*#__PURE__*/React.createElement("span", {
        className: classNames('rrui__switch__knob', {
          // CSS selector performance optimization
          'rrui__switch__knob--on': value
        })
      })), (rightLabel || isRightSideContent && children) && /*#__PURE__*/React.createElement("span", {
        className: classNames('rrui__text-line', 'rrui__switch__label', 'rrui__switch__label--right', {
          'rrui__switch__label--on': value
        })
      }, rightLabel || isRightSideContent && children));
    }
  }]);
  return Switch;
}(PureComponent);
_defineProperty(Switch, "propTypes", {
  // HTML form input `name` attribute
  name: PropTypes.string,
  // Disables the switch
  disabled: PropTypes.bool,
  // Either `true` or `false`
  value: PropTypes.bool.isRequired,
  // Is called when the switch is switched
  onChange: PropTypes.func.isRequired,
  // The label to the left of the switch
  leftLabel: PropTypes.string,
  // The label to the right of the switch
  rightLabel: PropTypes.string,
  // (deprecated, use `placement="left"`)
  // Set to `true` to output `children` on the right side.
  rightContent: PropTypes.bool,
  // Determines the placement of the toggle relative to `children`.
  // Is "right" by default.
  placement: PropTypes.oneOf(['left', 'right']),
  // A label (analogous to `leftLabel`)
  children: PropTypes.node,
  // CSS style object
  style: PropTypes.object,
  // CSS class
  className: PropTypes.string
});
_defineProperty(Switch, "defaultProps", {
  value: false,
  // Determines the placement of the toggle relative to `children`.
  // Is "right" by default.
  placement: 'right'
});
export { Switch as default };
var inputStyle = {
  position: 'absolute',
  opacity: 0,
  margin: 0
};
//# sourceMappingURL=Switch.js.map