var _excluded = ["accessible", "inline", "style", "className", "children", "placement", "content", "container", "component", "componentProps", "delay", "hideDelay", "hideTimeout", "hidingAnimationDuration", "screenMargin", "offsetTop", "tooltipClassName"];
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import classNames from 'classnames';

// For some weird reason, in Chrome, `setTimeout()` would lag up to a second (or more) behind.
// Turns out, Chrome developers have deprecated `setTimeout()` API entirely without asking anyone.
// Replacing `setTimeout()` with `requestAnimationFrame()` can work around that Chrome bug.
// https://github.com/bvaughn/react-virtualized/issues/722
import { setTimeout, clearTimeout } from 'request-animation-frame-timeout';
import { getOffset } from './utility/dom';

// `PureComponent` is only available in React >= 15.3.0.
var PureComponent = React.PureComponent || React.Component;

// https://github.com/Dogfalo/materialize/blob/master/js/tooltip.js
var Tooltip = /*#__PURE__*/function (_PureComponent) {
  _inherits(Tooltip, _PureComponent);
  var _super = _createSuper(Tooltip);
  function Tooltip() {
    var _this;
    _classCallCheck(this, Tooltip);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "state", {});
    _defineProperty(_assertThisInitialized(_this), "show", function () {
      _this.isShown = true;

      // Play tooltip showing animation
      var animate = false;

      // If hiding animation is being played,
      // then cancel it, and cancel setting
      // `display` to `none` after it finishes playing.
      if (_this.hide_timeout) {
        clearTimeout(_this.hide_timeout);
        _this.hide_timeout = undefined;

        // Abort tooltip hiding animation.
        // It will automatically return to the "showing" state.
        _this.tooltip.classList.remove('rrui__tooltip--before-hide');
      }
      // Otherwise, the tooltip is hidden (or never been shown)
      else {
        // Not creating in `componentDidMount()`
        // therefore create it here.
        if (!_this.tooltip) {
          _this.createTooltip();
        }

        // Play tooltip showing animation
        animate = true;
      }

      // Now that `this.tooltip` has been created,
      // re-render the component so that `ReactDOM.createPortal()` is called.
      return new Promise(function (resolve) {
        _this.setState({
          isShown: true
        }, function () {
          var accessible = _this.props.accessible;
          var _this$calculate_coord = _this.calculate_coordinates(),
            x = _this$calculate_coord.x,
            y = _this$calculate_coord.y;
          _this.tooltip.style.left = "".concat(x, "px");
          _this.tooltip.style.top = "".concat(y, "px");

          // Play tooltip showing animation
          // (doing it after setting position because
          //  setting position applies `display: block`)
          // (whatever that meant, the animation won't work
          //  if this is done before setting `left` and `top`)
          if (animate) {
            _this.tooltip.classList.add('rrui__tooltip--after-show');
          }
          if (_this.isTouchDevice) {
            document.addEventListener('touchstart', _this.hideOnTouchOutside);
          }
          resolve();
        });
      });
    });
    _defineProperty(_assertThisInitialized(_this), "hide", function () {
      _this.isShown = false;
      var hidingAnimationDuration = _this.props.hidingAnimationDuration;

      // If already hiding, or if already hidden, then do nothing.
      // if (this.hide_timeout || this.tooltip.style.display === 'none')
      if (_this.hide_timeout || !_this.tooltip) {
        return;
      }
      if (_this.isTouchDevice) {
        document.removeEventListener('touchstart', _this.hideOnTouchOutside);
      }

      // Play tooltip hiding animation
      _this.tooltip.classList.add('rrui__tooltip--before-hide');
      return new Promise(function (resolve) {
        // Set the tooltip to `display: none`
        // after its hiding animation finishes.
        _this.hide_timeout = setTimeout(function () {
          _this.hide_timeout = undefined;
          _this.destroy_tooltip();
          if (_this._isMounted) {
            _this.setState({
              isShown: false
            }, resolve);
          }
        }, hidingAnimationDuration);
      });
    });
    _defineProperty(_assertThisInitialized(_this), "hideOnTouchOutside", function (event) {
      if (_this.isShown) {
        // `this.tooltip` can be `undefined` when `this.isShown` is `true`
        // because `this.destroy_tooltip()` method is called before
        // `this.setState({ isShown: false })`, and also on "will unmount".
        if (_this.tooltip) {
          if (!_this.tooltip.contains(event.target) && !_this.origin.contains(event.target)) {
            _this.hide();
          }
        }
      }
    });
    _defineProperty(_assertThisInitialized(_this), "onClick", function () {
      if (_this.isShown) {
        _this.hide();
      } else {
        _this.show().then(function () {
          // An "accessible" tooltip is focused upon being shown.
          _this.tooltip.focus();
        });
      }
    });
    _defineProperty(_assertThisInitialized(_this), "onMouseMove", function () {
      document.removeEventListener('mousemove', _this.onMouseMove);
      _this.onMouseEnter();
    });
    _defineProperty(_assertThisInitialized(_this), "onMouseEnterTooltip", function () {
      // mouse enter and mouse leave events
      // are triggered on mobile devices too
      if (_this.isTouchDevice) {
        return;
      }
      _this.isPointerInsideTooltip = true;
      if (_this.isShown) {
        _this.cancelHide();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "onMouseLeaveTooltip", function () {
      // mouse enter and mouse leave events
      // are triggered on mobile devices too
      if (_this.isTouchDevice) {
        return;
      }
      _this.isPointerInsideTooltip = false;
      if (_this.isPointerInsideElement) {
        return;
      }
      if (_this.isShown) {
        _this.scheduleHide();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "onMouseEnter", function () {
      // mouse enter and mouse leave events
      // are triggered on mobile devices too
      if (_this.isTouchDevice) {
        return;
      }
      if (DocumentMouseMove.wasMouseMoved) {
        _this._onMouseEnter();
      } else {
        // This code handles the case when a user has scrolled
        // and the mouse pointer got placed over the minimized quote
        // but that didn't trigger the "expand" action (intentionally)
        // and then the user moves the mouse and that should expand
        // the minimized quote.
        document.addEventListener('mousemove', _this.onMouseMove);
      }
    });
    _defineProperty(_assertThisInitialized(_this), "onMouseLeave", function () {
      // mouse enter and mouse leave events
      // are triggered on mobile devices too
      if (_this.isTouchDevice) {
        return;
      }

      // The `mousemove` listener might have, or might have not,
      // been added, so remove it (if it has been added).
      document.removeEventListener('mousemove', _this.onMouseMove);
      _this.isPointerInsideElement = false;
      if (_this.isPointerInsideTooltip) {
        return;
      }

      // If tooltip hasn't been shown yet,
      // then cancel showing it.
      if (_this.show_timeout) {
        clearTimeout(_this.show_timeout);
        _this.show_timeout = undefined;
        return;
      }

      // Otherwise, the tooltip is shown, so hide it.
      if (_this.isShown) {
        _this.scheduleHide();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "onTouchStartSetTouchDevice", function () {
      return _this.isTouchDevice = true;
    });
    _defineProperty(_assertThisInitialized(_this), "onTouchStart", function () {
      var content = _this.renderContent();

      // mouse enter events won't be processed from now on
      _this.isTouchDevice = true;

      // If the tooltip has no content
      // (e.g. `react-time-ago` first render)
      // or if React Portal API is not available
      // then don't show the tooltip.
      if (!content || !ReactDOM.createPortal) {
        return;
      }
      if (_this.isShown) {
        _this.hide();
      } else {
        _this.show();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "onTouchEnd", function () {});
    // Is used on the tooltip itself in "accessible" mode.
    _defineProperty(_assertThisInitialized(_this), "onFocusOut", function (event) {
      if (!_this.tooltip.contains(event.relatedTarget) && !_this.origin.contains(event.relatedTarget)) {
        _this.hide();
      }
    });
    // This handler is used both on tooltip toggle button
    // and the tooltip itself.
    _defineProperty(_assertThisInitialized(_this), "onKeyDown", function (event) {
      if (event.defaultPrevented) {
        return;
      }
      if (event.ctrlKey || event.altKey || event.shiftKey || event.metaKey) {
        return;
      }
      switch (event.keyCode) {
        // Hide on "Escape".
        case 27:
          event.preventDefault();
          // Hide (if not already hidden).
          _this.hide();
          var accessible = _this.props.accessible;
          if (accessible) {
            _this.origin.focus();
          }
          return;
      }
    });
    _defineProperty(_assertThisInitialized(_this), "storeOriginNode", function (ref) {
      return _this.origin = ref;
    });
    return _this;
  }
  _createClass(Tooltip, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this._isMounted = true;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._isMounted = false;
      this.destroy_tooltip();
      clearTimeout(this.show_timeout);
      // The `mousemove` listener might have, or might have not,
      // been added, so remove it (if it has been added).
      document.removeEventListener('mousemove', this.onMouseMove);
    }
  }, {
    key: "createTooltip",
    value: function createTooltip() {
      var _this$props = this.props,
        tooltipClassName = _this$props.tooltipClassName,
        placement = _this$props.placement,
        accessible = _this$props.accessible;
      this.tooltip = document.createElement('div');
      this.tooltip.style.position = 'absolute';
      this.tooltip.style.left = 0;
      this.tooltip.style.top = 0;
      if (accessible) {
        // An "accessible" tooltip is focused upon being shown.
        this.tooltip.setAttribute('tabIndex', -1);
        this.tooltip.classList.add('rrui__outline');
        this.tooltip.addEventListener('focusout', this.onFocusOut);
      }
      this.tooltip.classList.add('rrui__tooltip');
      this.tooltip.classList.add("rrui__tooltip--".concat(getEdge(placement)));
      if (tooltipClassName) {
        for (var _iterator = _createForOfIteratorHelperLoose(tooltipClassName.split(/\s+/)), _step; !(_step = _iterator()).done;) {
          var className = _step.value;
          this.tooltip.classList.add(className);
        }
      }
      this.tooltip.addEventListener('mouseenter', this.onMouseEnterTooltip);
      this.tooltip.addEventListener('mouseleave', this.onMouseLeaveTooltip);
      this.tooltip.addEventListener('keydown', this.onKeyDown);
      this.container().appendChild(this.tooltip);
    }
  }, {
    key: "destroy_tooltip",
    value: function destroy_tooltip() {
      clearTimeout(this.hide_timeout);
      clearTimeout(this.hide_on_mouse_leave_timeout);
      if (this.tooltip) {
        // Won't throw an exception
        this.tooltip.parentNode.removeChild(this.tooltip);
        this.tooltip = undefined;
      }
    }
  }, {
    key: "container",
    value: function container() {
      var container = this.props.container;
      return container();
    }
  }, {
    key: "calculate_coordinates",
    value: function calculate_coordinates() {
      var _this$props2 = this.props,
        placement = _this$props2.placement,
        screenMargin = _this$props2.screenMargin,
        offsetTop = _this$props2.offsetTop;
      var width = this.tooltip.offsetWidth;
      var height = this.tooltip.offsetHeight;
      var origin = getOffset(this.origin);
      var top;
      var left;
      switch (getEdge(placement)) {
        case 'top':
          top = origin.top - height;
          break;
        case 'bottom':
          top = origin.top + origin.height;
          break;
        case 'left':
          left = origin.left - width;
          break;
        case 'right':
          left = origin.left + origin.width;
          break;
      }
      switch (getEdge(placement)) {
        case 'top':
        case 'bottom':
          switch (getSide(placement)) {
            case 'start':
              left = origin.left;
              break;
            case 'end':
              left = origin.left + origin.width - width;
              break;
            // Default: "center".
            default:
              left = origin.left + (origin.width - width) / 2;
              break;
          }
          break;
        case 'left':
        case 'right':
          switch (getSide(placement)) {
            case 'start':
              top = origin.top;
              break;
            case 'end':
              top = origin.top + origin.height - height;
              break;
            // Default: "center".
            default:
              top = origin.top + (origin.height - height) / 2;
              break;
          }
          break;
      }
      return fitOnScreen(left, top + offsetTop - getOffset(this.container()).top, width, height, screenMargin);
    }
  }, {
    key: "scheduleHide",
    value: function scheduleHide() {
      var _this$props3 = this.props,
        hideTimeout = _this$props3.hideTimeout,
        hideDelay = _this$props3.hideDelay;
      // `window.rruiCollapseOnFocusOut` can be used
      // for debugging expandable contents.
      if (window.rruiCollapseOnFocusOut !== false) {
        this.hide_on_mouse_leave_timeout = setTimeout(this.hide, hideTimeout || hideDelay);
      }
    }
  }, {
    key: "cancelHide",
    value: function cancelHide() {
      clearTimeout(this.hide_on_mouse_leave_timeout);
      this.hide_on_mouse_leave_timeout = undefined;
    }
  }, {
    key: "_onMouseEnter",
    value: function _onMouseEnter() {
      var _this2 = this;
      // mouse enter and mouse leave events
      // are triggered on mobile devices too
      if (this.isTouchDevice) {
        return;
      }
      this.isPointerInsideElement = true;
      if (this.isShown) {
        return this.cancelHide();
      }
      var content = this.renderContent();

      // If the tooltip has no content
      // (e.g. `react-time-ago` first render)
      // or if React Portal API is not available
      // then don't show the tooltip.
      if (!content || !ReactDOM.createPortal) {
        return;
      }

      // Shouldn't happen, because
      // `mouse leave` event clears this timeout.
      if (this.show_timeout) {
        return;
      }

      // If the tooltip hiding animation is currently playing,
      // then cancel it and re-show the tooltip.
      if (this.hide_timeout) {
        return this.show();
      }
      var delay = this.props.delay;

      // Don't show the tooltip immediately
      // but rather wait for the user to
      // "mouse over" it for a short time interval.
      // (prevents false positives)
      this.show_timeout = setTimeout(function () {
        _this2.show_timeout = undefined;
        _this2.show();
      }, delay);
    }
  }, {
    key: "renderContent",
    value: function renderContent() {
      var _this$props4 = this.props,
        content = _this$props4.content,
        Component = _this$props4.component,
        componentProps = _this$props4.componentProps;
      if (content) {
        return content;
      }
      if (Component) {
        return /*#__PURE__*/React.createElement(Component, _extends({}, componentProps, {
          hide: this.hide
        }));
      }
      return null;
    }
  }, {
    key: "render",
    value: function render() {
      // Shows tooltip on mouse over when on desktop.
      // Shows tooltip on touch when on mobile.

      // `ReactDOM.createPortal()` requires React >= 16.
      // If it's not available then it won't show the tooltip.

      var content = this.renderContent();
      var tooltip = this.tooltip && content && ReactDOM.createPortal && /*#__PURE__*/ReactDOM.createPortal(content, this.tooltip);

      // For React >= 16.2.
      // Disable React portal event bubbling.
      // https://github.com/facebook/react/issues/11387#issuecomment-340019419
      if (React.Fragment) {
        return /*#__PURE__*/React.createElement(React.Fragment, null, this._render(), tooltip);
      } else {
        // Legacy version support.
        // Can be a bit buggy in some rare cases of mouseentering and mouseleaving.
        // Will be removed in some future major version release.
        return this._render(tooltip);
      }
    }
  }, {
    key: "_render",
    value: function _render(extraChildren) {
      var _this$props5 = this.props,
        accessible = _this$props5.accessible,
        inline = _this$props5.inline,
        style = _this$props5.style,
        className = _this$props5.className,
        children = _this$props5.children,
        placement = _this$props5.placement,
        content = _this$props5.content,
        container = _this$props5.container,
        component = _this$props5.component,
        componentProps = _this$props5.componentProps,
        delay = _this$props5.delay,
        hideDelay = _this$props5.hideDelay,
        hideTimeout = _this$props5.hideTimeout,
        hidingAnimationDuration = _this$props5.hidingAnimationDuration,
        screenMargin = _this$props5.screenMargin,
        offsetTop = _this$props5.offsetTop,
        tooltipClassName = _this$props5.tooltipClassName,
        rest = _objectWithoutProperties(_this$props5, _excluded);
      var isShown = this.state.isShown;
      var Component = accessible ? 'button' : 'div';

      // There's no WAI-ARIA example of an `aria-role="tooltip"` widget.
      // https://www.w3.org/TR/wai-aria-practices-1.1/#tooltip
      //
      // `aria-haspopup`:
      // https://www.w3.org/TR/wai-aria-1.1/#aria-haspopup
      // WAI-ARIA 1.1 is not yet supported, so not using `aria-haspopup="..."`.

      return /*#__PURE__*/React.createElement(Component, _extends({}, rest, {
        ref: this.storeOriginNode,
        onMouseEnter: this.onMouseEnter,
        onMouseLeave: this.onMouseLeave,
        onClick: accessible ? this.onClick : undefined,
        onTouchStart: accessible ? this.onTouchStartSetTouchDevice : this.onTouchStart,
        onTouchEnd: accessible ? undefined : this.onTouchEnd,
        onTouchMove: accessible ? undefined : this.hide,
        onTouchCancel: accessible ? undefined : this.hide,
        "aria-expanded": accessible ? isShown : undefined,
        type: accessible ? 'button' : undefined,
        style: style,
        className: classNames(className, 'rrui__tooltip__target', {
          'rrui__button-reset': accessible,
          'rrui__tooltip__target--inline': inline
        })
      }), children, extraChildren);
    }
  }]);
  return Tooltip;
}(PureComponent);
_defineProperty(Tooltip, "propTypes", {
  // Tooltip placement.
  placement: PropTypes.oneOf(['top', 'top-start', 'top-end', 'left', 'left-start', 'left-end', 'bottom', 'bottom-start', 'bottom-end', 'right', 'right-start', 'right-end']).isRequired,
  // Tooltip content.
  content: PropTypes.node,
  // Tooltip content component.
  // Will have access to `hide()` property.
  component: PropTypes.func,
  componentProps: PropTypes.object,
  // Whether this element should be displayed as `inline-block`.
  // (is `true` by default)
  inline: PropTypes.bool.isRequired,
  // If `true` then the tooltip will be accessible via keyboard.
  // The tooltipped element will be wrapped in a focusable `<button/>`
  // that will show/hide the tooltip on click.
  // Tooltip contents will be focused upon being shown.
  // The tooltip will be closeable via `Esc` key.
  // The tooltip will still be shown/hidden on mouseover.
  // (is `false` by default)
  accessible: PropTypes.bool,
  // The delay before the tooltip is shown (in milliseconds)
  delay: PropTypes.number.isRequired,
  // The duration of the tooltip hiding animation.
  // The DOM element will retain `display: block` for this time period.
  // When changing this timeout also change `transition` time for
  // `.tooltip--after-show` and `.tooltip--before-hide` CSS classes.
  // Is `120` by default.
  hidingAnimationDuration: PropTypes.number.isRequired,
  // (`hideTimeout` is deprecated, use `hideDelay` instead)
  // The tooltip waits `hideTimeout` milliseconds before hiding
  // to support mouseovering over itself.
  hideTimeout: PropTypes.number,
  // The tooltip waits `hideDelay` milliseconds before hiding
  // to support mouseovering over itself.
  hideDelay: PropTypes.number.isRequired,
  screenMargin: PropTypes.number.isRequired,
  // When passing `offsetTop`, also set `--rrui-tooltip-visible-distance` to `0px`.
  offsetTop: PropTypes.number.isRequired,
  // `container: () => DOMElement` property is optional
  // and is gonna be the parent DOM Element for the tooltip itself
  // (`document.body` by default).
  // (in which case make sure that `document.body` has no `margin`
  //  otherwise tooltip `left` and `top` positions will be slightly off).
  container: PropTypes.func,
  // CSS style object
  style: PropTypes.object,
  // CSS class name
  className: PropTypes.string,
  // Tooltip CSS class name
  tooltipClassName: PropTypes.string
});
_defineProperty(Tooltip, "defaultProps", {
  placement: 'top',
  inline: true,
  delay: 350,
  // in milliseconds
  hidingAnimationDuration: 200,
  // in milliseconds
  hideDelay: 50,
  // in milliseconds
  screenMargin: 4,
  // in pixels
  offsetTop: 0,
  // in pixels
  container: function container() {
    return document.body;
  }
});
export { Tooltip as default };
function fitOnScreen(x, y, width, height, minimal_margin) {
  if (x < minimal_margin) {
    x = minimal_margin;
  } else if (x + width + minimal_margin > window.innerWidth) {
    x -= x + width + minimal_margin - window.innerWidth;
  }
  if (y < window.pageYOffset + minimal_margin) {
    y = window.pageYOffset + minimal_margin;
  } else if (y + height + minimal_margin > window.pageYOffset + window.innerHeight) {
    y -= y + height + minimal_margin - (window.pageYOffset + window.innerHeight);
  }
  return {
    x: x,
    y: y
  };
}

/**
 * @param  {string} placement
 * @return {string} One of: "top", "right", "bottom", "left".
 */
function getEdge(placement) {
  var dashIndex = placement.indexOf('-');
  if (dashIndex >= 0) {
    return placement.slice(0, dashIndex);
  }
  return placement;
}

/**
 * @param  {string} placement
 * @return {string} One of: "start", "center", "end".
 */
function getSide(placement) {
  var dashIndex = placement.indexOf('-');
  if (dashIndex >= 0) {
    return placement.slice(dashIndex + '-'.length);
  }
  return 'center';
}
var DocumentMouseMove = {
  wasMouseMoved: false
};
function onDocumentMouseMove() {
  DocumentMouseMove.wasMouseMoved = true;
}
function onDocumentScroll() {
  DocumentMouseMove.wasMouseMoved = false;
}

// There could be several thousand minimized post link quotes on a page
// (when not using `<VirtualScroller/>`). So, in order not to add
// several thousand `mousemove` and `scroll` listeners,
// a single one for each of these two events is added instead.
if (typeof document !== 'undefined') {
  document.addEventListener('mousemove', onDocumentMouseMove);
  document.addEventListener('scroll', onDocumentScroll);
}
//# sourceMappingURL=Tooltip.js.map