import ignoreInvalidDateObjects from './ignoreInvalidDateObjects';
describe('ignoreInvalidDateObjects', function () {
  it('should ignore invalid date objects', function () {
    var date = new Date(2018, 3, 5);
    expect(ignoreInvalidDateObjects(date)).to.equal(date);
    expect(ignoreInvalidDateObjects(null)).to.be.undefined;
    expect(ignoreInvalidDateObjects(new Date('a'))).to.be.undefined;
  });
});
//# sourceMappingURL=ignoreInvalidDateObjects.test.js.map