"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = ActivityIndicator;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); } // Taken from:
// https://loading.io/css/
//
// A colored variation:
// https://codeburst.io/how-to-create-a-simple-css-loading-spinner-make-it-accessible-e5c83c2e464c
function ActivityIndicator(props) {
  var className = props.className;
  return /*#__PURE__*/_react["default"].createElement("div", _extends({}, props, {
    className: (0, _classnames["default"])('rrui__activity-indicator', className)
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "rrui__activity-indicator__arc"
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "rrui__activity-indicator__arc"
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "rrui__activity-indicator__arc"
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "rrui__activity-indicator__arc"
  }));
}
ActivityIndicator.propTypes = {
  // CSS class
  className: _propTypes["default"].string,
  // CSS style object
  style: _propTypes["default"].object
};
//# sourceMappingURL=ActivityIndicator.js.map