"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Button = _interopRequireDefault(require("./Button"));
var _Modal = require("./Modal");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
// Prevents `<form/> submission when `wait` is `true`.
// And also inserts `<Form.Error/>` when `error` is passed.
// Using `Component` here instead of `PureComponent`
// because `<Form.Actions>` depends on `context` and therefore
// should be rerendered even if the `props` haven't changed.
// And probably that was also why it would keep displaying an old error
// (and not resetting it for some reason).
var Form = /*#__PURE__*/function (_Component) {
  _inherits(Form, _Component);
  var _super = _createSuper(Form);
  function Form() {
    var _this;
    _classCallCheck(this, Form);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "submit", function (event) {
      if (event) {
        event.preventDefault();
      }
      var _this$props = _this.props,
        wait = _this$props.wait,
        busy = _this$props.busy,
        submit = _this$props.submit;

      // Prevent form double submit
      // (because not only buttons submit a form,
      //  therefore just disabling buttons is not enough).
      if (wait || busy) {
        return;
      }
      if (submit) {
        return submit();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "on_key_down", function (event) {
      // Cancel editing on "Escape" key
      if (event.keyCode === 27) {
        var cancel = _this.props.cancel;
        if (cancel) {
          cancel();
        }
        event.preventDefault();
      }
    });
    return _this;
  }
  _createClass(Form, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        post = _this$props2.post,
        error = _this$props2.error,
        className = _this$props2.className,
        style = _this$props2.style;
      return /*#__PURE__*/_react["default"].createElement("form", {
        onSubmit: this.submit,
        onKeyDown: this.on_key_down,
        action: post,
        method: "POST",
        className: (0, _classnames["default"])('rrui__form', className),
        style: style,
        noValidate: true
      }, this.render_children(error));
    }

    // Adds `error` element to the form
  }, {
    key: "render_children",
    value: function render_children(error) {
      var children = this.props.children;
      var form_elements = _react["default"].Children.toArray(children);

      // Insert `error` element
      if (error) {
        // Will be set to `null` upon insertion
        var error_element = /*#__PURE__*/_react["default"].createElement(FormError, {
          key: "form-error"
        }, error);

        // Show form error above form actions,
        // so that the error will be visible and won't be overlooked.
        var index = 0;
        for (var _iterator = _createForOfIteratorHelperLoose(form_elements), _step; !(_step = _iterator()).done;) {
          var child = _step.value;
          // Workaround for `react-hot-loader`.
          // https://github.com/gaearon/react-hot-loader#checking-element-types
          if (child.type.displayName === 'FormError') {
            form_elements[index] = /*#__PURE__*/_react["default"].cloneElement(child, {
              key: 'form-error'
            }, error);
            error_element = null;
            break;
          }
          // Workaround for `react-hot-loader`.
          // https://github.com/gaearon/react-hot-loader#checking-element-types
          if (child.type.displayName === 'FormActions') {
            form_elements.insert_at(index, error_element);
            error_element = null;
            break;
          }
          index++;
        }
        if (error_element) {
          form_elements.push(error_element);
        }
      }
      return form_elements;
    }
  }]);
  return Form;
}(_react.Component); // I guess `<Form.Error/>` isn't used anywhere
// and is therefore considered deprecated.
exports["default"] = Form;
_defineProperty(Form, "propTypes", {
  // `onSubmit` handler
  submit: _propTypes["default"].func,
  // On `Escape` keydown handler
  cancel: _propTypes["default"].func,
  // `error` can be passed for non-javascript old-school forms.
  // e.g. when a form submitted via HTTP POST request had an error,
  // then this error is rendered as part of the form.
  error: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].bool, _propTypes["default"].node]),
  // The HTML form `action` attribute,
  // i.e. the URL to which the form will be posted
  // in case of a non-javascript old-school POST submission.
  post: _propTypes["default"].string,
  // Is form submission in progress
  wait: _propTypes["default"].bool.isRequired,
  // (deprecated)
  // (use `wait` instead)
  // Is form submission in progress
  busy: _propTypes["default"].bool.isRequired,
  // CSS class
  className: _propTypes["default"].string,
  // CSS style object
  style: _propTypes["default"].object
});
_defineProperty(Form, "defaultProps", {
  wait: false,
  busy: false
});
function FormError(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "rrui__form__error"
  }, children);
}

// Workaround for `react-hot-loader`.
// https://github.com/gaearon/react-hot-loader#checking-element-types
FormError.displayName = 'FormError';

// I guess `<Form.Error/>` isn't used anywhere
// and is therefore considered deprecated.
Form.Error = FormError;

// I guess `<Form.Actions/>` aren't used anywhere
// and are therefore considered deprecated.
var FormActions = /*#__PURE__*/function (_Component2) {
  _inherits(FormActions, _Component2);
  var _super2 = _createSuper(FormActions);
  function FormActions() {
    _classCallCheck(this, FormActions);
    return _super2.apply(this, arguments);
  }
  _createClass(FormActions, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var context = this.props.context;
      if (context) {
        context.registerForm();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var context = this.props.context;
      if (context) {
        context.unregisterForm();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        context = _this$props3.context,
        children = _this$props3.children,
        className = _this$props3.className,
        style = _this$props3.style;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('rrui__form__actions', className),
        style: style
      }, context && /*#__PURE__*/_react["default"].createElement(_Button["default"], {
        action: context.closeIfNotBusy
      }, context.closeLabel), children);
    }
  }]);
  return FormActions;
}(_react.Component); // Workaround for `react-hot-loader`.
// https://github.com/gaearon/react-hot-loader#checking-element-types
FormActions.displayName = 'FormActions';

// I guess `<Form.Actions/>` aren't used anywhere
// and are therefore considered deprecated.
Form.Actions = function (_ref2) {
  var children = _ref2.children;
  return /*#__PURE__*/_react["default"].createElement(_Modal.ModalContext.Consumer, null, function (context) {
    return /*#__PURE__*/_react["default"].createElement(FormActions, {
      context: context
    }, children);
  });
};
//# sourceMappingURL=Form.js.map