"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = MenuIcon;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function MenuIcon(_ref) {
  var expanded = _ref.expanded,
    className = _ref.className;
  // This is to prevent the `transform` animations
  // of menu icon bars from being played on page load.
  // (when styles are included on a page via javascript)
  var activated = expanded !== undefined;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(className, 'rrui__menu-icon', {
      'rrui__menu-icon--collapsed': !expanded,
      'rrui__menu-icon--expanded': expanded
    })
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "rrui__menu-icon__bar"
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "rrui__menu-icon__bar"
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "rrui__menu-icon__bar"
  }));
}
MenuIcon.propTypes = {
  expanded: _propTypes["default"].bool,
  className: _propTypes["default"].string
};
//# sourceMappingURL=MenuIcon.js.map