"use strict";

var _getDateForDayOfWeek = _interopRequireDefault(require("./getDateForDayOfWeek"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
describe('getDateForDayOfWeek', function () {
  it('should get date for day of week', function () {
    expect((0, _getDateForDayOfWeek["default"])(0).toDateString()).to.equal('Sun Jan 02 2000');
    expect((0, _getDateForDayOfWeek["default"])(1).toDateString()).to.equal('Mon Jan 03 2000');
    expect((0, _getDateForDayOfWeek["default"])(2).toDateString()).to.equal('Tue Jan 04 2000');
    expect((0, _getDateForDayOfWeek["default"])(3).toDateString()).to.equal('Wed Jan 05 2000');
    expect((0, _getDateForDayOfWeek["default"])(4).toDateString()).to.equal('Thu Jan 06 2000');
    expect((0, _getDateForDayOfWeek["default"])(5).toDateString()).to.equal('Fri Jan 07 2000');
    expect((0, _getDateForDayOfWeek["default"])(6).toDateString()).to.equal('Sat Jan 08 2000');
  });
});
//# sourceMappingURL=getDateForDayOfWeek.test.js.map