"use strict";

var _ignoreInvalidDateObjects = _interopRequireDefault(require("./ignoreInvalidDateObjects"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
describe('ignoreInvalidDateObjects', function () {
  it('should ignore invalid date objects', function () {
    var date = new Date(2018, 3, 5);
    expect((0, _ignoreInvalidDateObjects["default"])(date)).to.equal(date);
    expect((0, _ignoreInvalidDateObjects["default"])(null)).to.be.undefined;
    expect((0, _ignoreInvalidDateObjects["default"])(new Date('a'))).to.be.undefined;
  });
});
//# sourceMappingURL=ignoreInvalidDateObjects.test.js.map