import React from 'react';
import classNames from 'classnames';

// https://martinwolf.org/blog/2015/01/pure-css-savingloading-dots-animation
export default function Ellipsis(_ref) {
  var className = _ref.className,
    style = _ref.style;
  return /*#__PURE__*/React.createElement("div", {
    className: classNames('rrui__ellipsis', className),
    style: style
  }, /*#__PURE__*/React.createElement("div", {
    className: "rrui__ellipsis__size"
  }, /*#__PURE__*/React.createElement("div", {
    className: "rrui__ellipsis__dots"
  }, /*#__PURE__*/React.createElement("div", {
    className: "rrui__ellipsis__dot rrui__ellipsis__dot--1"
  }), /*#__PURE__*/React.createElement("div", {
    className: "rrui__ellipsis__dot rrui__ellipsis__dot--2"
  }), /*#__PURE__*/React.createElement("div", {
    className: "rrui__ellipsis__dot rrui__ellipsis__dot--3"
  }))));
}
//# sourceMappingURL=Ellipsis.js.map