var _excluded = ["as"];
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import createContext from 'create-react-context';
export var Context = createContext();

// export const contextPropTypes = {
// 	menuIsExpanded     : PropTypes.bool.isRequired,
// 	toggleMenu         : PropTypes.func.isRequired,
// 	registerMenu       : PropTypes.func.isRequired,
// 	registerMenuButton : PropTypes.func.isRequired,
// 	setTogglerCooldown : PropTypes.func.isRequired,
// 	getTogglerNode     : PropTypes.func.isRequired
// }
var PageAndMenu = /*#__PURE__*/function (_Component) {
  _inherits(PageAndMenu, _Component);
  var _super = _createSuper(PageAndMenu);
  function PageAndMenu() {
    var _this;
    _classCallCheck(this, PageAndMenu);
    _this = _super.call(this);
    // `state` is placed here to so that it's initialized
    // after all instance methods because it references them.
    _defineProperty(_assertThisInitialized(_this), "toggleMenu", function (expand) {
      _this.menu.toggle(expand, {
        onCollapsed: function onCollapsed() {
          _this._onDidShowMenu(false);
        },
        onExpanded: function onExpanded() {
          _this._onDidShowMenu(true);
        }
      });
    });
    _defineProperty(_assertThisInitialized(_this), "_onDidShowMenu", function (isShown) {
      _this.setState({
        menuIsExpanded: isShown
      });
      // Focus the menu when it's expanded.
      // Focus the menu button when menu is collapsed.
      if (isShown) {
        var menu = _this.menu.menu();
        // If the menu element supports focus.
        // (for example, via `tabIndex={-1}`).
        if (menu && menu.focus) {
          menu.focus();
        }
      } else {
        // The menu button might get unmounted when the menu is unmounted.
        if (_this.menuButton) {
          _this.menuButton.element().focus();
        }
      }
    });
    _defineProperty(_assertThisInitialized(_this), "registerMenu", function (menu) {
      if (_this.menu) {
        throw new Error('[react-responsive-ui] There already is a menu registered for this page.');
      }
      _this.menu = menu;
      // Return `.unregister()`.
      return function () {
        _this.menu = undefined;
        _this._onDidShowMenu(false);
      };
    });
    _defineProperty(_assertThisInitialized(_this), "registerMenuButton", function (menuButton) {
      if (_this.menuButton) {
        throw new Error('[react-responsive-ui] There already is a menu button registered for this page.');
      }
      _this.menuButton = menuButton;
      // Return `.unregister()`.
      return function () {
        _this.menuButton = undefined;
      };
    });
    _defineProperty(_assertThisInitialized(_this), "setTogglerCooldown", function () {
      return _this.menuButton.setCooldown();
    });
    _defineProperty(_assertThisInitialized(_this), "getTogglerNode", function () {
      return _this.menuButton.element();
    });
    _this.state = {
      // Using `undefined` for `menuIsExpanded` instead of `false`
      // because menu icon uses it to determine whether
      // the button has been activated yet.
      menuIsExpanded: undefined,
      // false,
      toggleMenu: _this.toggleMenu,
      registerMenu: _this.registerMenu,
      registerMenuButton: _this.registerMenuButton,
      setTogglerCooldown: _this.setTogglerCooldown,
      getTogglerNode: _this.getTogglerNode
    };
    return _this;
  }
  _createClass(PageAndMenu, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        Component = _this$props.as,
        rest = _objectWithoutProperties(_this$props, _excluded);
      return /*#__PURE__*/React.createElement(Context.Provider, {
        value: this.state
      }, /*#__PURE__*/React.createElement(Component, rest));
    }
  }]);
  return PageAndMenu;
}(Component);
export { PageAndMenu as default };
PageAndMenu.propTypes = {
  as: PropTypes.elementType.isRequired
};
PageAndMenu.defaultProps = {
  as: 'div'
};
//# sourceMappingURL=PageAndMenu.js.map